datablock AudioProfile(QuantumGunExplosionSound)
{
   filename    = "~/data/sound/QuantExp.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(ConRifleTrailParticle)
{
textureName = "~/data/shapes/weapons/plasma";
	useInvAlpha =  false;

	dragCoeffiecient = 100.0;
	inheritedVelFactor = 0.01;

	lifetimeMS = 1500;
	
	lifetimeVarianceMS = 10;

	times[0] = 0.0;
	times[1] = 0.8;
	times[2] = 1.0;

	colors[0] = "0.0 0.1 0.8 0.8";
	colors[1] = "0.0 0.2 0.8 0.8";
	colors[2] = "0.0 0.0 0.8 0.0";
	sizes[0] = 1.5;
	sizes[1] = 1.0;
	sizes[2] = 1.0;
};

datablock ParticleEmitterData(ConRifleTrailEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;

   ejectionVelocity = 0.5;
   velocityVariance = 0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = ConRifleTrailParticle;
};



datablock ParticleData( ConRifleBulletFireParticle )
{
	textureName = "~/data/shapes/weapons/plasma";
	useInvAlpha =  false;

	dragCoeffiecient = 100.0;
	inheritedVelFactor = 0.3;

	lifetimeMS = 1300;
	lifetimeVarianceMS = 200;

	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	colors[0] = "0.0 0.1 0.8 0.9";
	colors[1] = "0.0 0.2 0.8 0.8";
	colors[2] = "0.0 0.0 0.0 0.0";

	sizes[0] = 4.0;
	sizes[1] = 3.0;
	sizes[2] = 1.0;
};

datablock ParticleEmitterData( ConRifleBulletFireParticleEmitter )
{
	particles = "ConRifleBulletFireParticle";

	lifetimeMS = 250;
	lifetimeVarianceMS = 0;

	ejectionPeriodMS = 10;
	periodVarianceMS = 0;

	ejectionVelocity = 4.5;
	velocityVariance = 4.5;
};


datablock AudioProfile(ConRifleFireSound)
{
   filename    = "~/data/sound/ConRiflefire.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ExplosionData(ConRifleBulletExplosion)
{
   //explosionShape = "";
	soundProfile = QuantumGunExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = ConRifleBulletFireParticleEmitter;
   particleDensity = 300;
   particleRadius = 7;



   shakeCamera = true;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "10.0 10.0 10.0";
   camShakeDuration = 4.0;
   camShakeRadius = 20.0;

   // Dynamic light
   lightStartRadius = 15;
   lightEndRadius = 1;
   lightStartColor = "0.0 0.2 0.8 0.8";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(ConRifleBulletProjectile)
{
   projectileShapeName = "";
   directDamage        = 50;
   radiusDamage        = 15;
   damageRadius        = 10;
   explosion           = ConRifleBulletExplosion;
  particleEmitter     = ConRifleTrailEmitter;

   muzzleVelocity      = 500;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 8000;
   fadeDelay           = 7500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 15.0;
   lightColor  = "0.0 0.2 0.8 0.8";
damagetype        = '%1 was shattered by %2';
};


//////////
// item //
//////////
datablock ItemData(ConRifle)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/plasmasniper.dts";
	skinName = 'grayDark';
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a ConRifle.';
	invName = "ConRifle";
	image = ConRifleImage;
};




////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(ConRifleImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/plasmasniper.dts";
   skinName = 'brown';
   emap = true;
    
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = ConRifle;
   ammo = " ";
   projectile = ConRifleBulletProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 2.0;
	stateTransitionOnTimeout[0]       = "Ready";

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.5;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= ConRifleFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = true;
	stateTimeoutValue[3]            = 2.0;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";
	
	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};

function ConRifleBulletProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
tbmcollison(%this,%obj,%col,%fade,%pos,%normal);
       tbmradiusDamage
     (%obj, VectorAdd(%pos, VectorScale(%normal, 0.01)),
      %this.damageRadius,%this.radiusDamage,%this.damageType,60);
}

