datablock ExplosionData( FlashlightExplosion )
{
	

	lifeTimeMS = 1000000000;
    lifetimeVarianceMS = 0;




	
	

	// This will make the camera shake when a player gets hit by a rocket.
    // Shoot your own feet to see this effect in action.
	shakeCamera      = false;


	// This will create a dynamic lighting effect in the vicinity of the 
    // rocket's explosion.
	lightStartRadius = 10;
	lightEndRadius   = 10;
	lightColor  = "1.0 1.0 1.0 0.5";
	lightEndColor    = "1.0 1.0 1.0 0.5";
};




//weapon stuff




datablock ProjectileData(FlashlightProjectile)
{
   projectileShapeName = "";
   directDamage        = 0;
   radiusDamage        = 0;
   damageRadius        = 0;
   explosion           = FlashlightExplosion;
   muzzleVelocity      = 200;
   velInheritFactor    = 1;
   
   armingDelay         = 0;
   lifetime            = 20000;
   fadeDelay           = 90;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = false;
   lightRadius = 10.0;
   lightColor  = "1.0 1.0 1.0 0.5";
};
	


//////////
// item //
//////////
datablock ItemData(Flashlight)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/Loudhailer.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;
        skinname = 'white';
	 // Dynamic properties defined by the scripts
	pickUpName = 'a Flashlight.';
	invName = "Flashlight";
	image = FlashlightImage;
};

function Flashlight::onUse(%this, %player, %InvPosition)
{
	//check for quiver 
	//if you dont have it, regular bow
	//if you do, super bow

	%client = %player.client;

	%mountPoint = %this.image.mountPoint;
	%mountedImage = %player.getMountedImage(%mountPoint); 

	%skin = %this.skinname;

	if(%mountedImage)
	{
		if(%mountedImage == %this.image.getId())
		{
			//some kind of bow mounted so, unmount it
			%player.unMountImage(%mountPoint);
			messageClient(%client, 'MsgHilightInv', '', -1);
			%player.currWeaponSlot = -1;
		}
		else
		{
		%player.mountimage(%this.image.getId(), $RightHandSlot, 1, %skin);
		messageClient(%client, 'MsgHilightInv', '', %InvPosition);
		%player.currWeaponSlot = %invPosition;
		}
		
	}
	else
	{
	%player.mountimage(%this.image.getId(), $RightHandSlot, 1, %skin);
	messageClient(%client, 'MsgHilightInv', '', %InvPosition);
	%player.currWeaponSlot = %invPosition;
	}
}
////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(FlashlightImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/Loudhailer.dts";
   emap = true;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";
  skinname='white';
   // Projectile && Ammo.
   item = Flashlight;
   ammo = " ";
   projectile = FlashlightProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordinRPGy.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.01;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	
	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 1.0;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.01;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};


