datablock AudioProfile(GrenadeExplosionSound)
{
   filename    = "~/data/sound/GLExp.wav";
   description = AudioClose3d;
   preload = true;
};

datablock ParticleData(GLTrailParticle)
{
	dragCoefficient		= 0.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 1000;
	lifetimeVarianceMS	= 0;
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= false;
	animateTexture		= false;


	textureName		= "~/data/particles/dot";
	
	// Interpolation variables
	colors[0]	= "1 1 1 0.5";
	colors[1]	= "1 1 1 0.0";
	sizes[0]	= 0.2;
	sizes[1]	= 0.01;
	times[0]	= 0.0;
	times[1]	= 1.0;
};

datablock ParticleEmitterData(GLTrailEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = GLTrailParticle;
};


datablock ParticleData( GLSmokeParticle )
{
	textureName = "~/data/shapes/weapons/smoke";
	useInvAlpha =  true;

	dragCoeffiecient = 100.0;
	inheritedVelFactor = 0.3;
	constantAcceleration = -0.3;

	
	lifetimeMS = 1200;
	lifetimeVarianceMS = 300;

	times[0] = 0.0;

	times[1] = 0.5;
	times[2] = 1.0;

	colors[0] = "0.56 0.36 0.26 1.0";
	colors[1] = "0.2 0.2 0.2 1.0";
	colors[2] = "0.0 0.0 0.0 0.0";

	sizes[0] = 4.0;
	sizes[1] = 2.5;
	sizes[2] = 1.0;
};

datablock ParticleEmitterData( GLSmokeParticleEmitter )
{
	particles = "GLSmokeParticle";

	lifetimeMS = 250;
	lifetimeVarianceMS = 0;

	ejectionPeriodMS = 10;
	periodVarianceMS = 0;

	ejectionVelocity = 4;
	velocityVariance = 0.5;
};



datablock ExplosionData( GLExplosion )
{
	soundProfile = GrenadeExplosionSound;

	lifeTimeMS = 1600;
    lifetimeVarianceMS = 0;

	// Volume particles
	particleEmitter = GLFireParticleEmitter;
	particleDensity = 100;
	particleRadius  = 2;

	// Point emission particles
	emitter[0] = GLSmokeParticleEmitter;
	

	// This will make the camera shake when a player gets hit by a rocket.
    // Shoot your own feet to see this effect in action.
	shakeCamera      = true;
	camShakeFreq     = "10.0 11.0 10.0";
	camShakeAmp      = "0.5 0.5 0.5";
	camShakeDuration = 0.5;
	camShakeRadius   = 10.0;

	// This will create a dynamic lighting effect in the vicinity of the 
    // rocket's explosion.
	lightStartRadius = 6;
	lightEndRadius   = 3;
	lightStartColor  = "0.5 0.5 0.0";
	lightEndColor    = "0.0 0.0 0.0";
};




//weapon stuff

datablock AudioProfile(GLFireSound)
{
   filename    = "~/data/sound/GLFire.wav";
   description = AudioClosest3d;
   preload = true;
};



datablock ProjectileData(GLProjectile)
{
   projectileShapeName = "~/data/shapes/weapons/grenade.dts";
   directDamage        = 60;
   radiusDamage        = 25;
   damageRadius        = 3;
   explosion           = GLExplosion;
   particleEmitter     = GLTrailEmitter;
  muzzleVelocity      = 90;

   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 16000;
   fadeDelay           = 15500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 1;


   hasLight    = false;
   lightRadius = 10.0;
   lightColor  = "0.8 0.4 0.0";
damagetype        = '%1 was killed by shrapnel from %2\'s grenade';
};
	


//////////
// item //
//////////
datablock ItemData(GrenadeLauncher)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system
   skinname = 'green';
	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/Loudhailer.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a GrenadeLauncher.';
	invName = "GrenadeLauncher";
	image = GrenadeLauncherImage;
};

function GrenadeLauncher::onUse(%this, %player, %InvPosition)
{
	//check for quiver 
	//if you dont have it, regular bow
	//if you do, super bow

	%client = %player.client;

	%mountPoint = %this.image.mountPoint;
	%mountedImage = %player.getMountedImage(%mountPoint); 

	%skin = %this.skinname;

	if(%mountedImage)
	{
		if(%mountedImage == %this.image.getId())
		{
			//some kind of bow mounted so, unmount it
			%player.unMountImage(%mountPoint);
			messageClient(%client, 'MsgHilightInv', '', -1);
			%player.currWeaponSlot = -1;
		}
		else
		{
		%player.mountimage(%this.image.getId(), $RightHandSlot, 1, %skin);
		messageClient(%client, 'MsgHilightInv', '', %InvPosition);
		%player.currWeaponSlot = %invPosition;
		}
		
	}
	else
	{
	%player.mountimage(%this.image.getId(), $RightHandSlot, 1, %skin);
	messageClient(%client, 'MsgHilightInv', '', %InvPosition);
	%player.currWeaponSlot = %invPosition;
	}
}
////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(GrenadeLauncherImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/Loudhailer.dts";
   emap = true;
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   skinname = 'green';
   mountPoint = 0;
   offset = "0 0 0";
   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = GrenadeLauncher;
   ammo = " ";
   projectile = GLProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.05;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]		= true;
	stateSound[2]			= GLFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = false;
	stateTimeoutValue[3]            = 0.8;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};


function GLProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
tbmcollison(%this,%obj,%col,%fade,%pos,%normal);
tbmcollison(%this,%obj,%col,%fade,%pos,%normal);
       tbmradiusDamage
     (%obj, VectorAdd(%pos, VectorScale(%normal, 0.01)),
      %this.damageRadius,%this.radiusDamage,%this.damageType,20);
}
