

datablock ParticleData( PlasmaBulletSparkParticle )
{
	textureName = "~/data/shapes/weapons/spark";

	dragCoefficient      = 1;
	gravityCoefficient   = 0.0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;

	lifetimeMS = 500;
	lifetimeVarianceMS = 350;

	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	colors[0] = "0.0 0.0 0.8 1.0";
	colors[1] = "0.2 0.0 1.0 0.8";
	colors[2] = "0.6 0.6 1.0 0.1";

	sizes[0] = 0.20;
	sizes[1] = 0.15;
	sizes[2] = 0.5;
};

datablock ParticleEmitterData( PlasmaBulletSparkParticleEmitter )
{
	particles = "PlasmaBulletSparkParticle";

	lifetimeMS = 150;
    lifetimeVarianceMS = 0;

	ejectionPeriodMS = 2;
	periodVarianceMS = 0;

	ejectionVelocity = 17;
	velocityVariance = 5;
};





datablock ParticleData( PlasmaBulletFireParticle )
{
	textureName = "~/data/shapes/weapons/plasma";
	useInvAlpha =  false;

	dragCoeffiecient = 100.0;
	inheritedVelFactor = 0.3;

	lifetimeMS = 1200;
	lifetimeVarianceMS = 300;

	times[0] = 0.0;
	times[1] = 0.5;
	times[2] = 1.0;

	colors[0] = "0.15 0.0 0.5 0.4";
	colors[1] = "0.2 0.0 0.7 0.5";
	colors[2] = "0.0 0.0 0.7 0.7";

	sizes[0] = 3.5;
	sizes[1] = 2.5;
	sizes[2] = 2.5;
};

datablock ParticleEmitterData( PlasmaBulletFireParticleEmitter )
{
	particles = "PlasmaBulletFireParticle";

	lifetimeMS = 250;
	lifetimeVarianceMS = 0;

	ejectionPeriodMS = 10;
	periodVarianceMS = 0;

	ejectionVelocity = 4;
	velocityVariance = 0.5;
};


datablock AudioProfile(PlasmaSniperFireSound)
{
   filename    = "~/data/sound/plasmafire.wav";
   description = AudioClosest3d;
   preload = true;
};


datablock ExplosionData(PlasmaBulletExplosion)
{
   //explosionShape = "";
	soundProfile = QuantumGunExplosionSound;

   lifeTimeMS = 150;

   particleEmitter = PlasmaBulletFireParticleEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

  emitter[0] = PlasmaBulletSparkParticleEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(PlasmaBulletProjectile)
{
   projectileShapeName = "~/data/shapes/weapons/plasmashot.dts";
   directDamage        = 100;
   radiusDamage        = 100;
   damageRadius        = 0.5;
   explosion           = PlasmaBulletExplosion;
  particleEmitter     = PlasmaBulletFireParticleEmitter;

   muzzleVelocity      = 750;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 8000;
   fadeDelay           = 7500;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0.7 0 0.8";
damagetype        = '%1 was sniped by %2';
};


//////////
// item //
//////////
datablock ItemData(PlasmaSniper)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/plasmasniper.dts";
	skinName = 'grayDark';
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a PlasmaSniper.';
	invName = "PlasmaSniper";
	image = PlasmaSniperImage;
};





datablock AudioProfile(PlasmaChargeSound)
{
   filename    = "~/data/sound/charge.wav";
   description = AudioClosest3d;
   preload = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(PlasmaSniperImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/plasmasniper.dts";
   skinName = 'brown';
   emap = true;
    
   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = PlasmaSniper;
   ammo = " ";
   projectile = PlasmaBulletProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 5.0;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= PlasmaChargeSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Reload";
	stateTimeoutValue[2]            = 0.5;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= PlasmaSniperFireSound;

	stateName[3]			= "Reload";
	stateSequence[3]                = "Reload";
	stateAllowImageChange[3]        = true;
	stateTimeoutValue[3]            = 5.0;
	stateWaitForTimeout[3]		= true;
	stateTransitionOnTimeout[3]     = "Check";
	stateSound[3]					= PlasmaChargeSound;

	stateName[4]			= "Check";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	//stateSequence[5]                = "Reload";
	stateScript[5]                  = "onStopFire";


};

function PlasmaBulletProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
tbmcollison(%this,%obj,%col,%fade,%pos,%normal);
}

