//saw.cs
datablock AudioProfile(sawStartSound)
{
   filename    = "~/data/sound/chainsawstart.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(sawIdleSound)
{
   filename    = "~/data/sound/chainsawidle.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(sawFireSound)
{
   filename    = "~/data/sound/chainsawfire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(sawFireIdleSound)
{
   filename    = "~/data/sound/chainsawfireidle.wav";
   description = AudioClosest3d;
   preload = true;
};

//effects
datablock ParticleData(sawExplosionParticle)
{
   dragCoefficient      = 3;
   gravityCoefficient   = 0.2;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "~/data/shapes/weapons/spark";
   colors[0]     = "1.0 0.5 0.0 0.9";
   colors[1]     = "1.0 0.6 0.0 0.5";
   sizes[0]      = 0.025;
   sizes[1]      = 0.05;
};

datablock ParticleEmitterData(sawExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "sawExplosionParticle";
};

datablock ExplosionData(sawExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

  // soundProfile = sawHitSound;

   particleEmitter = sawExplosionEmitter;
   particleDensity = 20;
   particleRadius = 0.1;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
datablock ProjectileData(sawProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 20;
   radiusDamage        = 0;
   damageRadius        = 0.5;
   explosion           = sawExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 46;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 65;
   fadeDelay           = 60;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
damagetype        = '%1 was hacked up by %2';
};


//////////
// item //
//////////
datablock ItemData(saw)
{
	category = "Weapon";  // Mission editor category
	className = "Tool"; // For inventory system

	 // Basic Item Properties
	shapeFile = "~/data/shapes/weapons/saw.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	 // Dynamic properties defined by the scripts
	pickUpName = 'a saw.';
	invName = "Saw";
	image = sawImage;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(sawImage)
{
   // Basic Item properties
   shapeFile = "~/data/shapes/weapons/saw.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
    
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = saw;
   ammo = " ";
   projectile = sawProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 2.0;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= sawStartSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateTransitionOnTimeout[1]     = "Ready2";
	stateTimeoutValue[1]            = 1.6;
stateSound[1]					= sawIdleSound;
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
stateSound[2]					= sawFireSound;
		stateSequence[2]			  = "ignite";
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateSound[3]					= sawFireIdleSound;
	stateTimeoutValue[3]            = 0.1;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;


	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire2";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.1;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";

	stateName[6]                     = "Ready2";
	stateTransitionOnTriggerDown[6]  = "PreFire";
	stateTransitionOnTimeout[6]     = "Ready";
	stateTimeoutValue[6]            = 1.6;
stateSound[6]					= sawIdleSound;
	stateAllowImageChange[6]         = true;



	stateName[7]                    = "Fire2";
	stateTransitionOnTimeout[7]     = "CheckFire2";
	stateSound[7]					= sawFireIdleSound;
	stateTimeoutValue[7]            = 0.1;
	stateFire[7]                    = true;
	stateAllowImageChange[7]        = false;
	stateScript[7]                  = "onFire";
	stateWaitForTimeout[7]		= true;


	stateName[8]			= "CheckFire2";
	stateTransitionOnTriggerUp[8]	= "StopFire";
	stateTransitionOnTriggerDown[8]	= "Fire";


};


function sawProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{
tbmcollison(%this,%obj,%col,%fade,%pos,%normal);
}